## sdcc 3.3.0+dfsg

=== device/examples/ds390/Makefile ===
TARGETS = clock390 hello390 i2c390 readmac rtc390 ow390

all: $(TARGETS)
	for target in $(TARGETS); do \
		(cd $$target; $(MAKE)); \
	done;

clean: $(TARGETS)
	rm -f *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.rst *.sym *.lnk
	for target in $(TARGETS); do \
		(cd $$target; $(MAKE) clean); \
	done;

=== device/examples/ds390/hello390/Makefile ===
hello390.hex: hello390.c
	sdcc -mds390 --xram-loc 0x100080 --code-loc 0x10000 \
		-Wl-r hello390.c
	packihx hello390.ihx >hello390.hex
	#tinitalk -c execute hello390.hex

clean:
	rm -f *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.rst *.sym *.lnk core *.dump*

=== device/examples/ds390/rtc390/Makefile ===
CC = sdcc

MFLAGS = -mds390
LFLAGS = --xram-loc 0x100080 --code-loc 0x10000 -Wl-r

OBJECTS = rtc390.rel

all: rtc390.hex

clean:
	rm -f *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.rst *.sym *.lnk core *.dump*

rtc390.hex: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS) 
	packihx rtc390.ihx >rtc390.hex
	#tinitalk -c execute rtc390.hex

%.rel: %.c
	$(CC) -c $(MFLAGS) -I . $<

=== device/examples/ds400/hello400/Makefile ===
CC = ../../../../bin/sdcc

MFLAGS = -mds400
LFLAGS = --xram-loc 0x10000 --code-loc 0x400000 -Wl-r

OBJECTS = hello.rel

all: hello.hex

clean:
	rm -f *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.rst *.sym *.lnk

hello.hex: hello.ihx
	packihx hello.ihx >hello.hex

hello.ihx: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS)

%.rel: %.c
	$(CC) -c $(MFLAGS) $<

=== device/examples/mcs51/asmblink/Makefile ===
# makefile for Linux

all : blink.ihx

blink.ihx : blink.lnk
	asx8051 -los blink.asm
	aslink -f blink.lnk

blink.lnk : blink_lnk
	cp blink_lnk blink.lnk

clean:
	rm -f mon.ihx *.lst *.rel *.rst *.sym *.cdb *.map *.ihx

=== debian/changelog ===
sdcc (3.3.0+dfsg-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Remove build-indep from build target. Add it as a requisite of the
      install-indep target.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Mon, 30 Dec 2013 16:26:17 +0530

sdcc (3.3.0+dfsg-1) unstable; urgency=low

  * New upstream release (Closes: #422599, #671631, #724192)
  * Remove patch 02_fix_spelling. Fixed in upstream.
  * Update patch 01_disable_non-free
  * Bump compat to 9
  * Bump standards version to 3.9.4
  * Add dependency on dpkg-dev (>= 1.16.1~)
  * Add hardening buildflags to debian rules
  * Adding files to remove to clean target
  * Change dephelper dependency to 9
  * Add hardening wrapper
  * Add more scripts from support/scripts to package
  * Replace texlive-full dependency by a smaller dependency

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Wed, 02 Oct 2013 16:00:58 +0200

=== debian/control ===
Source: sdcc
Section: electronics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Depends: debhelper (>=9), autoconf, autotools-dev, libtool, 
 flex, bison, libncurses5-dev, gputils, libboost-dev, dpkg-dev (>= 1.16.1~),
 hardening-wrapper
Build-Depends-Indep: lyx, texlive-latex-recommended, texlive-generic-recommended,
 texlive-fonts-recommended, ghostscript
Standards-Version: 3.9.4
Homepage: http://sdcc.sourceforge.net
Vcs-Git: git://anonscm.debian.org/collab-maint/sdcc.git
Vcs-Browser: http://anonscm.debian.org/git/collab-maint/sdcc.git

Package: sdcc
Architecture: any
Depends: sdcc-libraries (= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: sdcc-doc
Suggests: sdcc-ucsim, python
Breaks: sdcc-libraries (<< 2.9.0)
Description: Small Device C Compiler
 SDCC is a C compiler for the Intel MCS51 family, AVR, HC08, PIC
 and Z80 microcontrollers.
 .
 This package includes the compiler, assemblers and linkers.

Package: sdcc-libraries
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: gputils
Description: Small Device C Compiler (libraries)
 SDCC is a C compiler for the Intel MCS51 family, AVR, HC08, PIC
 and Z80 microcontrollers.
 .
 This package contains the core library for SDCC.

Package: sdcc-ucsim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: sdcc
Replaces: sdcc-ucsim-snapshot
Description: Micro-controller simulator for SDCC
 uCsim is a microcontroller simulator. It is extensible to support
 different microcontroller families. It currently supports Intel 
 MCS51 family, HC08 and Z80 microcontrollers.

Package: sdcc-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: sdcc
Description: Small Device C Compiler (documentation)
 SDCC is a C compiler for the Intel MCS51 family, AVR, HC08, PIC
 and Z80 microcontrollers.
 .
 This package provides the documentation and examples for the
 SDCC compiler.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
	NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

export HOME=$(CURDIR)/build

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g -O0
	export STRIP=true
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

clean:
	dh_testdir
	dh_testroot
	# Clean up files that Makefile should have cleaned
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f device/lib/pic14/config.h
	rm -f device/lib/pic14/config.log
	rm -f device/lib/pic14/stamp-h1
	rm -f device/lib/r2k/*.asm
	rm -f device/lib/z180/*.asm
	rm -f sim/ucsim/cmd.src/cmdlex.cc
	rm -f sim/ucsim/cmd.src/cmdpars.cc
	rm -f src/pic14/Makefile.dep
	rm -f src/pic14/peeph.rul
	rm -rf $(CURDIR)/build
	rm -f custom.h
	rm -f sim/ucsim/custom.h
	rm -f support/regression/ports/host/spec.mk
	rm -f support/cpp/configargs.h,.log
	rm -f support/cpp/config.log
	rm -f support/cpp/config.status
	rm -f support/sdbinutils/binutils/arlex.c
	rm -f support/sdbinutils/binutils/arparse.c
	rm -f support/sdbinutils/binutils/arparse.h
	rm -f sim/ucsim/config.guess
	rm -f sim/ucsim/config.sub
	rm -f sim/ucsim/config.log
	rm -f config.log
	rm -f device/lib/small-stack-auto/Makefile
	rm -f as/link/asxxxx_config.h
	rm -f support/cpp/configargs.h
	rm -f ports.all ports.build
	rm -f confdefs.h
	find -type f -name '*.o' -exec rm -f {} \;
	find -type f -name '.stamp' -exec rm -f {} \;
	find . -name '*.rel' -exec rm -f {} \;
	find . -name '*.sym' -exec rm -f {} \;
	find . -name '*.lst' -exec rm -f {} \;
	find . -name '*.a' -exec rm -f {} \;
	find . -name config.status -exec rm -f {} \;
	find . -name Makefile -exec rm -f {} \;
	rm -f sim/ucsim/cmd.src/cmdpars.hh
	# Clean up the Debian specific files
	rm -f config.status doc/sdccman.ps
	rm -f *-stamp
	rm -f install-indep install-arch
	dh_clean

configure: configure-stamp
configure-stamp:
	dh_testdir
	mkdir -p $(CURDIR)/build
	cp /usr/share/misc/config.sub sim/ucsim/config.sub
	cp /usr/share/misc/config.guess sim/ucsim/config.guess
	./configure \
		--host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		--prefix=/usr
	touch $@

build: build-arch
build-arch: build-arch-stamp
build-arch-stamp: configure-stamp 
	dh_testdir
	$(MAKE) $(NJOBS)
	touch $@

build-indep: build-indep-stamp
build-indep-stamp: configure-stamp
	dh_testdir
	cd doc && lyx -e ps sdccman.lyx
	touch $@

install: install-arch install-indep
install-indep: build-indep
	dh_testdir
	dh_testroot
	dh_installdirs 
	dh_prep
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
	mkdir -p debian/tmp/usr/share/doc/sdcc-doc
	install -o root -g root -m 644 doc/sdccman.ps debian/tmp/usr/share/doc/sdcc-doc
	mv debian/tmp/usr/share/doc/sdcc/* debian/tmp/usr/share/doc/sdcc-doc/
	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/combined_i186_z80_design.tex
	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/Makefile
	#Remove extra license file
	rm -f $(CURDIR)/debian/tmp/usr/share/sdcc/lib/src/pic16/COPYING
	# Remove empty dirs:
	find $(CURDIR)/debian/tmp -type d -empty -delete

	#Clean up unnecessary directories
	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`

	dh_install -i --sourcedir=debian/tmp

	# Install examples
	cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
	rm -f $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc/examples/mcs51/simple*/go*

	touch $@

install-arch: build-arch
	dh_testdir
	dh_testroot
	dh_installdirs 
	dh_prep
	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr

	# Remove empty dirs:
	find $(CURDIR)/debian/tmp -type d -empty -delete

	#Clean up unnecessary directories
	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`
	# Add some scripts
	mkdir -p debian/tmp/usr/share/sdcc/scripts
	install -o root -g root -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
	install -o root -g root -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
	# Remove an unnecessary script 
	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl

	dh_install -a --sourcedir=debian/tmp

	touch $@

# Must not depend on anything. This is to be called by binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installman
	#dh_installexamples -psdcc-doc device/examples/* -X\.bat  
	dh_installemacsen
	dh_link
	dh_lintian
	dh_strip -Xusr/share/sdcc/lib/
	dh_compress 
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-independent files here.
binary-indep: install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture-dependent files here.
binary-arch: install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

get-orig-source:
	VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-+~]+).*,\1,p'); \
	uscan --force-download --rename --download-version=$$VER --destdir=. && (\
	tar -xj --exclude device/non-free --exclude sim/ucsim/libltdl -f sdcc_$$VER.orig.tar.bz2 ; \
	mv sdcc-$$VER sdcc-$$VER+dfsg;\
	tar -czf sdcc_$$VER+dfsg.orig.tar.gz sdcc-$$VER+dfsg; \
	rm -rf sdcc-$$VER+dfsg ;\
	rm -f sdcc_$$VER.orig.tar.bz2);

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-arch install-indep

## sdcc 3.4.0+dfsg

=== debian/changelog ===
sdcc (3.4.0+dfsg-2) unstable; urgency=medium

  * Add patch 03_fix_compilation (Closes: #752972, #752071)
  * Update hardening
  * Replace sdld6808, sdldz80 and sdldgb by a symbolic link to sdld.
    It was the same file eariler 
  * Added a few missing binaries to package

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Wed, 02 Jul 2014 22:41:35 +0000

sdcc (3.4.0+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #699842,#746906)
  * Bump standards version to 3.9.5
  * Add patch 02_fix_spelling to fix minor spelling error
  * Add rm GPL and LGPL to prevent double license files
  * 

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Sat, 12 Apr 2014 21:24:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: sdcc
 Section: electronics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
+Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
 Uploaders: Bdale Garbee <bdale@gag.com>
 Build-Depends: debhelper (>=9), autoconf, autotools-dev, libtool, 
- flex, bison, libncurses5-dev, gputils, libboost-dev, dpkg-dev (>= 1.16.1~),
- hardening-wrapper
+ flex, bison, libncurses5-dev, gputils, libboost-dev, dpkg-dev (>= 1.16.1~)
 Build-Depends-Indep: lyx, texlive-latex-recommended, texlive-generic-recommended,
  texlive-fonts-recommended, ghostscript
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://sdcc.sourceforge.net
 Vcs-Git: git://anonscm.debian.org/collab-maint/sdcc.git
 Vcs-Browser: http://anonscm.debian.org/git/collab-maint/sdcc.git

=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,11 @@
 #!/usr/bin/make -f
 
 export DH_VERBOSE=1
-export DEB_BUILD_HARDENING=1
-
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
+
+export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
+export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
+export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
+export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
 
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
@@ -58,12 +59,17 @@
 	rm -f support/cpp/configargs.h
 	rm -f ports.all ports.build
 	rm -f confdefs.h
+	rm -rf device/lib/pic1*/.check*
+	rm -f device/lib/pic1*/config.*
+	rm -f device/lib/pic16/stamp-h1
 	find -type f -name '*.o' -exec rm -f {} \;
 	find -type f -name '.stamp' -exec rm -f {} \;
 	find . -name '*.rel' -exec rm -f {} \;
 	find . -name '*.sym' -exec rm -f {} \;
 	find . -name '*.lst' -exec rm -f {} \;
 	find . -name '*.a' -exec rm -f {} \;
+	find . -name '*.cod' -exec rm -f {} \;
+	find . -name '*.hex' -exec rm -f {} \;
 	find . -name config.status -exec rm -f {} \;
 	find . -name Makefile -exec rm -f {} \;
 	rm -f sim/ucsim/cmd.src/cmdpars.hh
@@ -79,13 +85,18 @@
 	mkdir -p $(CURDIR)/build
 	cp /usr/share/misc/config.sub sim/ucsim/config.sub
 	cp /usr/share/misc/config.guess sim/ucsim/config.guess
+	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
 	./configure \
 		--host=$(DEB_HOST_GNU_TYPE) \
 		--build=$(DEB_BUILD_GNU_TYPE) \
-		--prefix=/usr
-	touch $@
-
-build: build-arch
+		--disable-non-free \
+		--disable-pic14-port \
+		--disable-pic16-port \
+		--prefix=/usr \
+
+	touch $@
+
+build: build-arch build-indep
 build-arch: build-arch-stamp
 build-arch-stamp: configure-stamp 
 	dh_testdir
@@ -99,7 +110,7 @@
 	touch $@
 
 install: install-arch install-indep
-install-indep: build-indep
+install-indep: build
 	dh_testdir
 	dh_testroot
 	dh_installdirs 
@@ -123,6 +134,8 @@
 	# Install examples
 	cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
 	rm -f $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc/examples/mcs51/simple*/go*
+	rm -f debian/sdcc-libraries/usr/share/sdcc/lib/src/pic14/GPL
+	rm -f debian/sdcc-libraries/usr/share/sdcc/lib/src/pic14/LGPL
 
 	touch $@
 
@@ -132,6 +145,12 @@
 	dh_installdirs 
 	dh_prep
 	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
+	rm -f $(CURDIR)/debian/tmp/usr/bin/sdld6808
+	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdld6808
+	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldz80
+	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldz80
+	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldgb
+	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldgb
 
 	# Remove empty dirs:
 	find $(CURDIR)/debian/tmp -type d -empty -delete
@@ -144,7 +163,6 @@
 	install -o root -g root -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
 	# Remove an unnecessary script 
 	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl
-
 	dh_install -a --sourcedir=debian/tmp
 
 	touch $@

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg$// http://qa.debian.org/watch/sf.php/sdcc/sdcc-src-([0-9]\.[0-9]\.[0-9])\.tar\.bz2 debian uupdate

## sdcc 3.5.0+dfsg

=== device/examples/Makefile ===

#DO_GCC=1
DO_Z80=1
#DO_MCS51=1

ifdef DO_GCC
CC = gcc -Wall -g
endif

ifdef DO_Z80
OBJEXT=o
CC = sdcc
MFLAGS = --debug -mz80
endif

ifdef DO_MCS51
OBJEXT=rel
CC = sdcc
MFLAGS = --debug --model-small --stack-after-data
#CFLAGS = -V
#MFLAGS = --debug --model-large --stack-after-data
#LFLAGS = --xram-loc 0x4000 --code-loc 0x0000
endif


#OBJECTS = test3.c itoa.$(OBJEXT) crc.$(OBJEXT)
OBJECTS = test3.c itoa.$(OBJEXT)

all: test3.ihx

ifdef DO_MCS51
an429.ihx : an429.c
	sdcc --model-small an429.c

test2.ihx : test2.c
	sdcc --model-small test2.c
endif

%.$(OBJEXT): %.c
	$(CC) -c $(CFLAGS) $(MFLAGS) $<

itoa.rel : itoa.c
	$(CC) -c $(CFLAGS) $(MFLAGS) itoa.c

#crc.rel : crc.c
#	$(CC) -c $(CFLAGS) $(MFLAGS) crc.c

test3.ihx: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS)

test3.bin: test3.ihx
	makebin < test3.ihx > test3.bin

clean:
	rm -f core *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.o \
		*.rst *.sym *.lnk *.lib *.bin

testser: test3.ihx
	s51 -Sout=serial.log test3.ihx

=== src/regression/Makefile ===
# Regression testing Makefile for Pic Port of SDCC
#
# note that this regression suite was started before
# the one in sdcc/regression. The regression suite in
# sdcc/regression is better suited for testing mature
# ports.
#
# GPL'd
#
# T. Scott Dattalo scott@dattalo.com
#
# This makefile provides a means by which the output
# of the SDCC Compiler can be tested. This version
# is unique to the PIC (as in Microchip PIC) port.
# As such it requires the following software:
#
#  gpasm version 0.11.1 (or greater)
#  gpsim version 0.20.7 (or greater)
#
# Usage:
#
# make
#  - without any options the whole regression test is
#    performed. The results are placed into a log file
#    (defined by $LOGFILE).
#
# make asm
#  - Creates .asm files by compiling the .c files
#
# make cod
#  - Creates .cod files by assembling the .asm files
#    (.cod files are symbolic files compatible with
#    MPASM, Microchip's assembler)
#
# make stc
#  - Creates .stc files which are script files for
#    gpsim.
#
# make clean
#  - removes all of the intermediate files created
#
# make cleancod
# make cleanasm
# make cleanstc
# make cleano
#  - removes either the .stc, .asm, .cod or .o files

# verboseness
#Q ?= # be verbose
Q ?= @ # be quiet

SDCC_SRC=../..
SDCC_BIN=../..

CC = $(SDCC_BIN)/bin/sdcc
LINKER = gplink
USE_PIC16 ?= 0
ifeq ($(strip $(filter 1 yes,$(USE_PIC16))),)
TARGETPIC = 16f877
#TARGETPIC = 16f84
CFLAGS = -mpic14 -p$(TARGETPIC)
DIR = pic14
else
TARGETPIC = 18f452
CFLAGS	= -mpic16 -p$(TARGETPIC)
DIR = pic16
endif
CFLAGS += -Wl,-q
CFLAGS += -Wl,--map
CFLAGS += -I $(SDCC_SRC)/device/include/$(DIR) -I $(SDCC_SRC)/device/non-free/include/$(DIR)
CFLAGS += -L $(SDCC_BIN)/device/lib/build/$(DIR) -L $(SDCC_BIN)/device/non-free/lib/build/$(DIR)
#CFLAGS += --no-pcode-opt
#CFLAGS += -V

.SUFFIXES: .asm .c .cod .stc
.NOTPARALLEL:

# Results of the test are placed here:
LOGFILE = test.log

# Script file for creating gpsim scripts
CREATESTC = create_stc

# Script file for invoking gpsim
SIMULATE = simulate

# List the C files to be test here:
SRC = add.c \
      add2.c \
      add3.c \
      add4.c \
      and1.c \
      and2.c \
      arrays.c \
      b.c \
      bank1.c \
      bool1.c \
      bool2.c \
      bool3.c \
      call1.c \
      compare.c \
      compare10.c \
      compare2.c \
      compare3.c \
      compare4.c \
      compare5.c \
      compare6.c \
      compare7.c \
      compare8.c \
      compare9.c \
      configword.c \
      empty.c \
      for.c \
      init0.c \
      inline.c \
      mult1.c \
      nestfor.c \
      or1.c \
      pcodeopt.c \
      pointer1.c \
      ptrarg.c \
      ptrfunc.c \
      rotate1.c \
      rotate2.c \
      rotate3.c \
      rotate4.c \
      rotate5.c \
      rotate6.c \
      rotate7.c \
      string1.c \
      struct1.c \
      sub.c \
      sub2.c \
      switch1.c \
      while.c \
      xor.c

COD := $(patsubst %.c, %.cod, $(SRC))
ASM := $(patsubst %.c, %.asm, $(SRC))
O   := $(patsubst %.c, %.o,   $(SRC))
P   := $(patsubst %.c, %.p,   $(SRC))
STC := $(patsubst %.c, %.stc, $(SRC))
HEX := $(patsubst %.c, %.hex, $(SRC))
LST := $(patsubst %.c, %.lst, $(SRC))
MAP := $(patsubst %.c, %.map, $(SRC))

all:	test


# The cod files are generated by sdcc
.c.cod:
	$(Q)-$(CC) $(CFLAGS) $*.c

# The .stc files are script files for gpsim
.cod.stc:
	$(Q)-./$(CREATESTC) $*.cod $*.stc
	$(Q)-./$(SIMULATE) $*.stc $(LOGFILE)

# this will also make .stc files
#%.stc : %.cod
#	./create_stc $^ $@

# now for the dependencies

cod : $(COD)

o : $(O)

asm : $(ASM)

stc : $(STC)
	echo $(STC)

test:	$(STC)
	$(Q)echo "Done - Results are in $(LOGFILE)"

cleancod:
	files="$(COD)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleano:
	files="$(O)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanp:
	files="$(P)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanasm:
	files="$(ASM)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanstc:
	files="$(STC)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanhex:
	files="$(HEX)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanlst:
	files="$(LST)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

cleanmap:
	files="$(MAP)" ; \
	for f in $$files ; do \
	  if [ -f $$f ]; then rm $$f; fi \
	done ; \

clean: cleancod cleanasm cleanstc cleano cleanp cleanhex cleanlst cleanmap
	if [ -f "$(LOGFILE)" ]; then rm $(LOGFILE); fi

=== device/examples/ds390/tinitalk/Makefile ===
CFLAGS=-Wall -g

tinitalk: tinitalk.c tinitalk.h
	cc -o $@ $(CFLAGS) $<
	cp $@ /usr/local/bin

clean:
	rm -f core *~ *.o tinitalk \#*

=== device/examples/ds400/monitor400/Makefile ===
CC = ../../../../bin/sdcc

MFLAGS = -mds400
LFLAGS = --xram-loc 0x10000 --code-loc 0x400000 -Wl-r

OBJECTS = mon400.rel

all: mon400.hex

clean:
	rm -f *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map *.rst *.sym *.lnk

mon400.hex: mon400.ihx
	packihx mon400.ihx >mon400.hex

mon400.ihx: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS)

%.rel: %.c
	$(CC) -c $(MFLAGS) $<

=== device/examples/mcs51/clock/Makefile ===
CC = sdcc
#CFLAGS = -V
MFLAGS = --model-small --debug
#MFLAGS = --model-large
LFLAGS = --xram-loc 0x4000 --code-loc 0x0000

all: clock.bin

OBJECTS = clock.rel hwinit.rel

clock.bin: clock.ihx
	hex2bin <clock.ihx >clock.bin
	cat clock.bin >/dev/par0
	cu -l /dev/ttyS0 -s 19200 dir

clock.ihx: $(OBJECTS)
	$(CC) $(MFLAGS) $(LFLAGS) $(OBJECTS)

clean:
	rm -f core *~ \#* *.asm *.cdb *.rel *.hex *.ihx *.lst *.map \
		*.rst *.sym *.lnk *.lib *.bin

%.rel: %.c hw.h
	$(CC) -c $(CFLAGS) $(MFLAGS) $<

=== debian/changelog ===
sdcc (3.5.0+dfsg-2build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:42:51 +0000

sdcc (3.5.0+dfsg-2) unstable; urgency=medium

  * Add dependency on gsfonts (Closes: #818447)
  * Bump standards version to 3.9.7, no changes needed
  * Remove breaks version 2.9.0
  * Add breaks version 3.4.0, sdar was moved from
    sdcc-ucsim to sdcc. (Closes: #803660)
  * Add patch 03_spelling to fix spelling error
  * Change vcs browser from http to https
  * Add hardening += all to build options

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Sat, 19 Mar 2016 19:31:13 +0100

sdcc (3.5.0+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #789831)
  * Improve manpages asxxxx and sdcc
  * Add manpages sdar, sdas390, sdasrab, sdasstm8, sdastlcs90,
    sdldstm8, sdnm, sdobjcopy, sstm8
  * Remove manpage savr
  * Remove patches, 02_fix_spelling and 03_fix_compilation. Fixed
    in upstream.
  * Bump standards version to 3.9.6
  * Remove unneeded lines from clean target in rules file
  * Update description i control file (Closes: #766325)
  * Move sdar from sdcc-ucsim to sdcc
  * Add binary file sdldstm8 to sdcc
  * Add huge memory model libraries (Closes: #768307)
  * Add dependency on graphicsmagick-imagemagick-compat
  * Exclude example code from compression
  * Add patch 02_enable_ppc64.patch (Closes: #766478)
  * Use autotools-dev to support new arches

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Fri, 16 Oct 2015 21:52:11 +0200

=== debian/control ===
Source: sdcc
Section: electronics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
Uploaders: Bdale Garbee <bdale@gag.com>
Build-Depends: autoconf,
	       autotools-dev,
               bison,
               debhelper (>=9),
               dpkg-dev (>= 1.16.1~),
               flex,
               gputils,
               libboost-dev,
               libncurses5-dev,
               libtool
Build-Depends-Indep: ghostscript,
                     graphicsmagick-imagemagick-compat,
                     lyx,
                     texlive-fonts-recommended,
                     texlive-generic-recommended,
                     texlive-latex-recommended,
                     gsfonts
Standards-Version: 3.9.7
Homepage: http://sdcc.sourceforge.net
Vcs-Git: https://anonscm.debian.org/collab-maint/sdcc.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/sdcc.git

Package: sdcc
Architecture: any
Depends: sdcc-libraries (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: sdcc-doc
Suggests: python, sdcc-ucsim
Breaks: sdcc-ucsim (<< 3.5.0)
Replaces: sdcc-ucsim (<< 3.5.0)
Description: Small Device C Compiler
 SDCC is a C compiler for the Intel MCS51 family, HC08, PIC,
 GameBoy Z80, DS80S390, Z80, Z180 and STM8 microcontrollers.
 .
 This package includes the compiler, assemblers and linkers.

Package: sdcc-libraries
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: gputils
Description: Small Device C Compiler (libraries)
 SDCC is a C compiler for the Intel MCS51 family, HC08, PIC,
 GameBoy Z80, DS80S390, Z80, Z180 and STM8 microcontrollers.
 .
 This package contains the core library for SDCC.

Package: sdcc-ucsim
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: sdcc
Replaces: sdcc-ucsim-snapshot
Description: Micro-controller simulator for SDCC
 uCsim is a microcontroller simulator. It is extensible to support
 different microcontroller families. It currently supports Intel
 MCS51 family, HC08 and Z80 microcontrollers.

Package: sdcc-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: sdcc
Description: Small Device C Compiler (documentation)
 SDCC is a C compiler for the Intel MCS51 family, HC08, PIC,
 GameBoy Z80, DS80S390, Z80, Z180 and STM8 microcontrollers.
 .
 This package provides the documentation and examples for the
 SDCC compiler.

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 
 export DH_VERBOSE=1
 
+export DEB_BUILD_MAINT_OPTIONS := hardening=+pie,+bindnow
 export CPPFLAGS=$(shell dpkg-buildflags --get CPPFLAGS)
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
@@ -29,62 +30,24 @@
 clean:
 	dh_testdir
 	dh_testroot
-	# Clean up files that Makefile should have cleaned
 	[ ! -f Makefile ] || $(MAKE) distclean
-	rm -f device/lib/pic14/config.h
-	rm -f device/lib/pic14/config.log
-	rm -f device/lib/pic14/stamp-h1
-	rm -f device/lib/r2k/*.asm
-	rm -f device/lib/z180/*.asm
-	rm -f sim/ucsim/cmd.src/cmdlex.cc
-	rm -f sim/ucsim/cmd.src/cmdpars.cc
-	rm -f src/pic14/Makefile.dep
-	rm -f src/pic14/peeph.rul
 	rm -rf $(CURDIR)/build
-	rm -f custom.h
-	rm -f sim/ucsim/custom.h
-	rm -f support/regression/ports/host/spec.mk
-	rm -f support/cpp/configargs.h,.log
-	rm -f support/cpp/config.log
-	rm -f support/cpp/config.status
 	rm -f support/sdbinutils/binutils/arlex.c
 	rm -f support/sdbinutils/binutils/arparse.c
 	rm -f support/sdbinutils/binutils/arparse.h
-	rm -f sim/ucsim/config.guess
-	rm -f sim/ucsim/config.sub
-	rm -f sim/ucsim/config.log
-	rm -f config.log
-	rm -f device/lib/small-stack-auto/Makefile
-	rm -f as/link/asxxxx_config.h
-	rm -f support/cpp/configargs.h
-	rm -f ports.all ports.build
+	rm -f sim/ucsim/config.sub sim/ucsim/config.guess
+	rm -f config.log sim/ucsim/config.log
 	rm -f confdefs.h
-	rm -rf device/lib/pic1*/.check*
-	rm -f device/lib/pic1*/config.*
-	rm -f device/lib/pic16/stamp-h1
-	find -type f -name '*.o' -exec rm -f {} \;
-	find -type f -name '.stamp' -exec rm -f {} \;
-	find . -name '*.rel' -exec rm -f {} \;
-	find . -name '*.sym' -exec rm -f {} \;
-	find . -name '*.lst' -exec rm -f {} \;
-	find . -name '*.a' -exec rm -f {} \;
-	find . -name '*.cod' -exec rm -f {} \;
-	find . -name '*.hex' -exec rm -f {} \;
-	find . -name config.status -exec rm -f {} \;
-	find . -name Makefile -exec rm -f {} \;
-	rm -f sim/ucsim/cmd.src/cmdpars.hh
-	# Clean up the Debian specific files
-	rm -f config.status doc/sdccman.ps
-	rm -f *-stamp
-	rm -f install-indep install-arch
+	rm -f install-arch install-indep
+	dh_autotools-dev_restoreconfig
 	dh_clean
 
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
 	mkdir -p $(CURDIR)/build
-	cp /usr/share/misc/config.sub sim/ucsim/config.sub
-	cp /usr/share/misc/config.guess sim/ucsim/config.guess
+	touch sim/ucsim/config.guess sim/ucsim/config.sub
+	dh_autotools-dev_updateconfig
 	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
 	./configure \
 		--host=$(DEB_HOST_GNU_TYPE) \
@@ -92,8 +55,7 @@
 		--disable-non-free \
 		--disable-pic14-port \
 		--disable-pic16-port \
-		--prefix=/usr \
-
+		--prefix=/usr
 	touch $@
 
 build: build-arch build-indep
@@ -129,7 +91,7 @@
 	#Clean up unnecessary directories
 	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`
 
-	dh_install -i --sourcedir=debian/tmp
+	dh_install -i --sourcedir=debian/tmp --list-missing
 
 	# Install examples
 	cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
@@ -163,7 +125,7 @@
 	install -o root -g root -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
 	# Remove an unnecessary script 
 	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl
-	dh_install -a --sourcedir=debian/tmp
+	dh_install -a --sourcedir=debian/tmp --list-missing
 
 	touch $@
 
@@ -180,7 +142,7 @@
 	dh_link
 	dh_lintian
 	dh_strip -Xusr/share/sdcc/lib/
-	dh_compress 
+	dh_compress --exclude=.c --exclude=.h --exclude=.cpp
 	dh_fixperms
 	dh_installdeb
 	dh_shlibdeps

## sdcc 3.7.0+dfsg2

=== src/regression/Makefile ===
--- 
+++ 
@@ -65,7 +65,7 @@
 CFLAGS	= -mpic16 -p$(TARGETPIC)
 DIR = pic16
 endif
-CFLAGS += -Wl,-q
+CFLAGS += -Wl,-q --no-warn-non-free
 CFLAGS += -Wl,--map
 CFLAGS += -I $(SDCC_SRC)/device/include/$(DIR) -I $(SDCC_SRC)/device/non-free/include/$(DIR)
 CFLAGS += -L $(SDCC_BIN)/device/lib/build/$(DIR) -L $(SDCC_BIN)/device/non-free/lib/build/$(DIR)

=== debian/changelog ===
sdcc (3.7.0+dfsg2-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Repack upstream tarball to exclude GFDL documentation with invariant
    sections
  * Fix doc-base file pointer to include .gz extension for manual
  * Add information to README.source about repacking upstream

 -- Jonathan McDowell <noodles@earth.li>  Tue, 31 Jul 2018 14:52:21 +0800

sdcc (3.7.0+dfsg-0.2) unstable; urgency=medium

  * Move texinfo to binary Build-Dep

 -- Jonathan McDowell <noodles@earth.li>  Sun, 29 Jul 2018 18:35:56 +0800

sdcc (3.7.0+dfsg-0.1) unstable; urgency=medium

  [ Geert Stappers ]
  * Non-maintainer upload.
  * Recreated git repo content (Closes: #895345)
  * Git repo at Salsa

  [ Jonathan McDowell ]
  * New upstream release (Closes: #892869)
    + Fixes FTBFS with GCC 8 (Closes: #897856)
    + Removed patches as all now applied upstream
    + Enable building of PDF manual
    + Fix ucsim docs to include SVGs instead of GIFs
  * Mark sdcc-doc + sdcc-libraries Multi-Arch foreign
  * Remove Bdale from uploaders, on his request

 -- Jonathan McDowell <noodles@earth.li>  Sun, 29 Jul 2018 15:02:20 +0800

sdcc (3.5.0+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add patch from Dr. Tobias Quathamer to fix FTBFS with lyx 2.3.
    (Closes: #894619)

 -- Adrian Bunk <bunk@debian.org>  Wed, 18 Apr 2018 19:34:21 +0300

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,7 @@
 Source: sdcc
 Section: electronics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
-Uploaders: Bdale Garbee <bdale@gag.com>
+Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
 Build-Depends: autoconf,
 	       autotools-dev,
                bison,
@@ -13,18 +11,20 @@
                gputils,
                libboost-dev,
                libncurses5-dev,
-               libtool
+               libtool,
+               texinfo
 Build-Depends-Indep: ghostscript,
                      graphicsmagick-imagemagick-compat,
                      lyx,
                      texlive-fonts-recommended,
+                     texlive-font-utils,
                      texlive-generic-recommended,
                      texlive-latex-recommended,
                      gsfonts
 Standards-Version: 3.9.7
 Homepage: http://sdcc.sourceforge.net
-Vcs-Git: https://anonscm.debian.org/collab-maint/sdcc.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/sdcc.git
+Vcs-Git: https://salsa.debian.org/electronics-team/sdcc.git
+Vcs-Browser: https://salsa.debian.org/electronics-team/sdcc
 
 Package: sdcc
 Architecture: any
@@ -43,6 +43,7 @@
 
 Package: sdcc-libraries
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Recommends: gputils
 Description: Small Device C Compiler (libraries)
@@ -64,6 +65,7 @@
 Package: sdcc-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Suggests: sdcc
 Description: Small Device C Compiler (documentation)

=== debian/rules ===
--- 
+++ 
@@ -68,7 +68,7 @@
 build-indep: build-indep-stamp
 build-indep-stamp: configure-stamp
 	dh_testdir
-	cd doc && lyx -e ps sdccman.lyx
+	cd doc && make
 	touch $@
 
 install: install-arch install-indep
@@ -79,7 +79,7 @@
 	dh_prep
 	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
 	mkdir -p debian/tmp/usr/share/doc/sdcc-doc
-	install -o root -g root -m 644 doc/sdccman.ps debian/tmp/usr/share/doc/sdcc-doc
+	install -o root -g root -m 644 doc/sdccman.pdf debian/tmp/usr/share/doc/sdcc-doc
 	mv debian/tmp/usr/share/doc/sdcc/* debian/tmp/usr/share/doc/sdcc-doc/
 	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/combined_i186_z80_design.tex
 	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/Makefile

## sdcc 3.8.0+dfsg

=== sim/ucsim/s51.src/test/Makefile ===
PRJ		= test_mdu517 test_mdu88x \
		  stn stp strr sts stt stxr stxrw stxw \
		  stt_small stt_large

all:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk clean all ;\
	done

clean:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk clean ;\
	done
	rm -f *.out *.sout *.tim *.csv *.sim
	rm -f st*[56][0-9][0-9].cmd st*[56]*.txt

=== sim/ucsim/stm8.src/test/Makefile ===
PROJECTS	= a s0 s1 s2 s3 t1 t2 t3 t4 xtest \
		  sl ss lled sled ltim stim sertest \
		  getbl \
		  monitor

.PHONY: projects $(PROJECTS)

projects: $(PROJECTS)

$(PROJECTS):
	$(MAKE) MAIN=$@ -f sdcc.mk

clean:
	for p in $(PROJECTS); do \
		$(MAKE) MAIN=$$p -f sdcc.mk clean ;\
		rm -rf $$p*.hex ;\
		rm -rf $$p*.cdb ;\
	done

=== debian/changelog ===
sdcc (3.8.0+dfsg-3build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 19:17:45 +0100

sdcc (3.8.0+dfsg-3) unstable; urgency=medium

  * Bump standards version to 4.4.1
  * Change texlive dependency (Closes: #941546)

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Sun, 06 Oct 2019 13:40:34 +0200

sdcc (3.8.0+dfsg-2) unstable; urgency=medium

  * Add build dependency on texlive-latex-extra (Closing #917692)
  * Bump standards version to 4.3.0, no changes needed

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Tue, 01 Jan 2019 17:59:22 +0100

sdcc (3.8.0+dfsg-1) unstable; urgency=medium

  [ Jonathan McDowell ]
  * Add myself to Uploaders and move under the Electronics Packaging Team.
  * Move to debhelper compat level 10.
  * Rename git-buildpackage section header to just buildpackage.

  [ Gudjon I. Gudjonsson ]
  * New upstream release
  * Remove a few autogenerated files from git and add to debian/rules
    clean target.
  * Don't install device/examples, removed from upstream
  * Bump standards to 4.2.1
  * Change watch from http to https
  * Add patch to fix spelling 01_fix_spelling.patch
  * Fix spelling error in ucsim and sdcc manpages
  * Change version check to DEB_VERSION_UPSTREAM in rules file
  * Add override file to remove false lintian gfdl positives
  * Add dependency on zlib1g-dev
  * Add dependency on inkscape (Closes: #911713)
  * Change .c files to non executable in rules
  * Make clean targer remove config.log and Makefile

 -- Gudjon I. Gudjonsson <gudjon@gudjon.org>  Tue, 30 Oct 2018 09:51:18 +0100

=== debian/control ===
--- 
+++ 
@@ -1,27 +1,30 @@
 Source: sdcc
 Section: electronics
 Priority: optional
-Maintainer: Gudjon I. Gudjonsson <gudjon@gudjon.org>
-Build-Depends: autoconf,
-	       autotools-dev,
-               bison,
-               debhelper (>=9),
+Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@alioth-lists.debian.net>
+Uploaders: Gudjon I. Gudjonsson <gudjon@gudjon.org>,
+	Jonathan McDowell <noodles@earth.li>
+Build-Depends: bison,
+               debhelper (>= 10),
                dpkg-dev (>= 1.16.1~),
                flex,
                gputils,
                libboost-dev,
                libncurses5-dev,
                libtool,
-               texinfo
+               texinfo,
+               zlib1g-dev
 Build-Depends-Indep: ghostscript,
                      graphicsmagick-imagemagick-compat,
                      lyx,
                      texlive-fonts-recommended,
                      texlive-font-utils,
-                     texlive-generic-recommended,
+                     texlive-plain-generic,
                      texlive-latex-recommended,
-                     gsfonts
-Standards-Version: 3.9.7
+                     texlive-latex-extra,
+                     gsfonts,
+                     inkscape
+Standards-Version: 4.4.1
 Homepage: http://sdcc.sourceforge.net
 Vcs-Git: https://salsa.debian.org/electronics-team/sdcc.git
 Vcs-Browser: https://salsa.debian.org/electronics-team/sdcc

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,6 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/pkg-info.mk
 
 export DH_VERBOSE=1
 
@@ -35,19 +37,34 @@
 	rm -f support/sdbinutils/binutils/arlex.c
 	rm -f support/sdbinutils/binutils/arparse.c
 	rm -f support/sdbinutils/binutils/arparse.h
-	rm -f sim/ucsim/config.sub sim/ucsim/config.guess
-	rm -f config.log sim/ucsim/config.log
 	rm -f confdefs.h
 	rm -f install-arch install-indep
-	dh_autotools-dev_restoreconfig
+	rm -f doc/sdcc_version
+	rm -f sim/ucsim/cmd.src/cmdlex.cc
+	rm -f device/lib/stm8-large/Makefile
+	rm -f device/lib/stm8-large/*.asm
+	rm -f device/lib/stm8-large/*.lst
+	rm -f device/lib/stm8-large/*.rel
+	rm -f device/lib/stm8-large/*.sym
+	rm -f support/sdbinutils/binutils/mcparse.[c,h]
+	rm -f support/sdbinutils/binutils/rcparse.[c,h]
+	rm -f support/sdbinutils/binutils/sysinfo.[c,h]
+	rm -f support/sdbinutils/binutils/syslex.[c,h]
+	rm -f support/sdbinutils/binutils/defparse.[c,h]
+	rm -f sim/ucsim/config.log
+	rm -f sim/ucsim/lex.yy.c
+	rm -f support/sdbinutils/bfd/doc/bfd.info
+	rm -f support/sdbinutils/bfd/doc/bfdver.texi
+	find . -type f -name 'Makefile' -exec rm -vf {} \;
+	find . -type f -name 'config.log' -exec rm -vf {} \;
 	dh_clean
 
 configure: configure-stamp
 configure-stamp:
 	dh_testdir
 	mkdir -p $(CURDIR)/build
-	touch sim/ucsim/config.guess sim/ucsim/config.sub
-	dh_autotools-dev_updateconfig
+	chmod a-x device/lib/*.c
+	dh_update_autotools_config
 	CFLAGS="$(CFLAGS)" CPPFLAGS="$(CPPFLAGS)" CXXFLAGS="$(CXXFLAGS)" LDFLAGS="$(LDFLAGS)" \
 	./configure \
 		--host=$(DEB_HOST_GNU_TYPE) \
@@ -94,7 +111,7 @@
 	dh_install -i --sourcedir=debian/tmp --list-missing
 
 	# Install examples
-	cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
+	#cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
 	rm -f $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc/examples/mcs51/simple*/go*
 	rm -f debian/sdcc-libraries/usr/share/sdcc/lib/src/pic14/GPL
 	rm -f debian/sdcc-libraries/usr/share/sdcc/lib/src/pic14/LGPL
@@ -159,11 +176,12 @@
 	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common
 
 get-orig-source:
-	VER=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-+~]+).*,\1,p'); \
+	set -e;\
+	VER=$(DEB_VERSION_UPSTREAM);\
 	uscan --force-download --rename --download-version=$$VER --destdir=. && (\
 	tar -xj --exclude device/non-free --exclude sim/ucsim/libltdl -f sdcc_$$VER.orig.tar.bz2 ; \
 	mv sdcc-$$VER sdcc-$$VER+dfsg;\
-	tar -czf sdcc_$$VER+dfsg.orig.tar.gz sdcc-$$VER+dfsg; \
+	tar -caf sdcc_$$VER+dfsg.orig.tar.xz sdcc-$$VER+dfsg; \
 	rm -rf sdcc-$$VER+dfsg ;\
 	rm -f sdcc_$$VER.orig.tar.bz2);

## sdcc 4.0.0+dfsg

=== sim/ucsim/s51.src/test/Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 PRJ		= test_mdu517 test_mdu88x \
 		  stn stp strr sts stt stxr stxrw stxw \
-		  stt_small stt_large
+		  stt_small stt_large \
+		  monitor test_ser tim_ser
 
 all:
 	for p in $(PRJ); do \

=== sim/ucsim/stm8.src/test/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-PROJECTS	= a s0 s1 s2 s3 t1 t2 t3 t4 xtest \
+PROJECTS	= s0 s1 s2 s3 t1 t2 t3 t4 xtest \
 		  sl ss lled sled ltim stim sertest \
 		  getbl \
 		  monitor

=== sim/ucsim/tlcs.src/test/Makefile ===
PRJ		= t0 t1 t2 t3 b2385

all:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk ;\
	done

clean:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk clean ;\
	done

=== sim/ucsim/z80.src/test/Makefile ===
PRJ		= t0 t1 t2

all:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk ;\
	done

clean:
	for p in $(PRJ); do \
		$(MAKE) -f $$p.mk clean ;\
	done

=== debian/changelog ===
sdcc (4.0.0+dfsg-2) unstable; urgency=medium

  * Add missing Padauk assemblers/linker (Closes: #960596)

 -- Jonathan McDowell <noodles@earth.li>  Sat, 16 May 2020 10:09:37 +0100

sdcc (4.0.0+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #951898)
    * Update spelling correction patch
    * sdcclib is no longer shipped
    * Fixes FTBFS (Closes: #959651)
  * Switch to librsvg2-bin instead of inkscape for SVG to EPS conversion
  * Switch to dh_missing rather than passing flag to dh_install
  * Install sdas documentation (Closes: #949433)

 -- Jonathan McDowell <noodles@earth.li>  Wed, 13 May 2020 19:19:27 +0100

=== debian/control ===
--- 
+++ 
@@ -23,7 +23,7 @@
                      texlive-latex-recommended,
                      texlive-latex-extra,
                      gsfonts,
-                     inkscape
+                     librsvg2-bin
 Standards-Version: 4.4.1
 Homepage: http://sdcc.sourceforge.net
 Vcs-Git: https://salsa.debian.org/electronics-team/sdcc.git

## sdcc 4.2.0~osmocom1.109.97c6

=== debian/changelog ===
sdcc (4.2.0~osmocom1.109.97c6) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom master feed

 -- Osmocom OBS scripts <info@osmocom.org>  Tue, 15 Apr 2025 08:21:20 +0000

sdcc (4.2.0~osmocom1) unstable; urgency=medium

  * Fix the build.

 -- Oliver Smith <osmith@sysmocom.de>  Tue, 15 Apr 2025 09:42:52 +0200

sdcc (4.2.0+dfsg-1) unstable; urgency=medium

  * New upstream release (Closes: #1006922)
    * Update spelling correction patch
    * Add lintian override for no-code-sections in target libs

 -- Jonathan McDowell <noodles@earth.li>  Wed, 30 Nov 2022 22:06:14 +0000

=== debian/rules ===
--- 
+++ 
@@ -96,7 +96,7 @@
 	dh_prep
 	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
 	mkdir -p debian/tmp/usr/share/doc/sdcc-doc
-	install -o root -g root -m 644 doc/sdccman.pdf debian/tmp/usr/share/doc/sdcc-doc
+	install -m 644 doc/sdccman.pdf debian/tmp/usr/share/doc/sdcc-doc
 	mv debian/tmp/usr/share/doc/sdcc/* debian/tmp/usr/share/doc/sdcc-doc/
 	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/combined_i186_z80_design.tex
 	rm -f debian/tmp/usr/share/doc/sdcc-doc/z80/Makefile
@@ -108,7 +108,8 @@
 	#Clean up unnecessary directories
 	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`
 
-	dh_install -i --sourcedir=debian/tmp --list-missing
+	dh_install -i
+	dh_missing --list-missing
 
 	# Install examples
 	#cp -a device/examples $(CURDIR)/debian/sdcc-doc/usr/share/doc/sdcc-doc
@@ -126,10 +127,14 @@
 	$(MAKE) install prefix=$(CURDIR)/debian/tmp/usr
 	rm -f $(CURDIR)/debian/tmp/usr/bin/sdld6808
 	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdld6808
+	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldgb
+	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldgb
+	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldpdk
+	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldpdk
+	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldstm8
+	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldstm8
 	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldz80
 	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldz80
-	rm -f $(CURDIR)/debian/tmp/usr/bin/sdldgb
-	cd $(CURDIR)/debian/tmp/usr/bin/ && ln -s sdld sdldgb
 
 	# Remove empty dirs:
 	find $(CURDIR)/debian/tmp -type d -empty -delete
@@ -138,8 +143,8 @@
 	rm -rf `find $(CURDIR)/debian/tmp -type d -name .deps`
 	# Add some scripts
 	mkdir -p debian/tmp/usr/share/sdcc/scripts
-	install -o root -g root -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
-	install -o root -g root -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
+	install -m 755  support/scripts/*.pl debian/tmp/usr/share/sdcc/scripts
+	install -m 755  support/scripts/*.py debian/tmp/usr/share/sdcc/scripts
 	# Remove an unnecessary script 
 	rm -f debian/tmp/usr/share/sdcc/scripts/gen_known_bugs.pl
 	dh_install -a --sourcedir=debian/tmp --list-missing

## sdcc 4.2.0~osmocom2.111.04d6

=== debian/changelog ===
sdcc (4.2.0~osmocom2.111.04d6) unstable; urgency=medium

  * Automatically generated changelog entry for building the Osmocom master feed

 -- Osmocom OBS scripts <info@osmocom.org>  Tue, 23 Sep 2025 07:43:59 +0000

sdcc (4.2.0~osmocom2) unstable; urgency=medium

  * debian/rules: use -std=gnu17

 -- Oliver Smith <osmith@sysmocom.de>  Tue, 23 Sep 2025 09:29:49 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: sdcc
 Section: electronics
 Priority: optional
-Maintainer: Debian Electronics Packaging Team <pkg-electronics-devel@alioth-lists.debian.net>
+Maintainer: Osmocom team <openbsc@lists.osmocom.org>
 Uploaders: Gudjon I. Gudjonsson <gudjon@gudjon.org>,
 	Jonathan McDowell <noodles@earth.li>
 Build-Depends: bison,

=== debian/rules ===
--- 
+++ 
@@ -9,6 +9,10 @@
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS)
 export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
+
+# GCC 15 changes the default to C23, breaking this version of SDCC. Revert it.
+# https://www.gnu.org/software//gcc/gcc-15/porting_to.html#c23
+CFLAGS += -std=gnu17
 
 # These are used for cross-compiling and for saving the configure script
 # from having to guess our platform (since we know it already)
